//Distributed under Kellen's sort-of-free license.
//http://people.colgate.edu/kmyers/license.html
//(c) Kellen Myers and Joseph Parrish 2007

// vim:set ts=4:
#include <stdio.h>
#include "colorings.h"
#include "stats.h"

float color_progress(coloring_t *c)
{
	int j;
	float p, f;
	for (j = 2, p = 0.0, f = 50.0; j <= c->last_bit; j++, f /= 2.0) {
		if (color_read(c, j)) p += f;
	}
	return p;
}

float color_progress_2(coloring_t *c, int n)
{
	int j;
	float p, f;
	for (j = 2 + n, p = 0.0, f = 50.0; j <= c->last_bit; j++, f /= 2.0) {
		if (color_read(c, j)) p += f;
	}
	return p;
}

void color_dump(coloring_t *c)
{
	int j;
	printf("COLOR = ");
	for (j = 1; j <= c->last_bit; j++) {
		printf("%c", color_read(c, j) ? 'B' : 'r');
	}
	printf("\n");
}

int color_dump_2(coloring_t *c, char *buf, int len)
{
	int j;
	int left = len;
	int n;
	n = snprintf(buf, left, "COLOR = ");
	left -= n; buf += n;
	for (j = 1; j <= c->last_bit; j++) {
		n = snprintf(buf, left, "%c", color_read(c, j) ? 'B' : 'r');
		left -= n; buf += n;
	}
	n = snprintf(buf, left, "\n");
	left -= n; buf += n;
	return len - left;
}

void var_dump(int *var_array, int num_vars)
{
	int j;
	for (j = 0; j < num_vars; j++) {
		printf("#%d=%d.  ", j, var_array[j]);
	}
	printf("\n");
}

int num_in_color(coloring_t *c)
{
	int j;
	int t = 0;
	for (j = 1; j <= c->last_bit; j++) {
		if (color_read(c, j) == color_read(c, c->last_bit)) t++;
	}
	return t;
}

